<template>
	<view class="container">
		<view class="bg" >
			<image  src="../../static/default/i_bg.png" style="width: 100%;height:100%" mode="aspectFill"></image>
		</view>
		<view class="wrapper u-relative" style="padding-top: 48rpx;box-sizing: border-box;">
			<view class="nav" style="width: 100%;height: 96rpx;"></view>
			<view class="input-content">
				<view style="font-size: 58rpx;font-weight: bold;color: #333;margin-bottom: 48rpx;">注册</view>

				<view class="cu-form-group">
					<view class="title">手机号</view>
					<view class="input" style="padding-left: 20rpx;">
						<input  class="input" type="number" :value="data.mobile" placeholder="请输入手机号" maxlength="11" data-key="mobile"
							@input="inputChange" />
					</view>
					
				</view>
				<view class="cu-form-group">
					<text class="title">验证码</text>
					<view class="input flex" style="padding-left: 20rpx;padding-right: 20rpx;">
						<input type="number" :value="data.code" placeholder="请输入验证码" maxlength="6" data-key="code"
						@input="inputChange" @confirm="toRegister" />
						<button class="send-msg" @click="sendMsg" :disabled="data.sending">{{ data.sendTime }}</button>
					</view>
				</view>

				<view class="cu-form-group">
					<text class="title">设置密码</text>
					<view class="input" style="padding-left: 20rpx;">
						<input class="input" type="password" :value="data.password" placeholder="请设置新密码" placeholder-class="input-empty"
							maxlength="20" minlength="6" data-key="password" @input="inputChange" @confirm="toRegister" />
					</view>
					
				</view>
				<button class="confirm-btn" @click="toRegister">注册</button>
				<button class="confirm-btn" @click="toLogin">登录</button>
			</view>
			<view class="footerView">
				<u-checkbox-group>
					<u-checkbox v-model="data.checked" label-size='24upx' shape="circle" @change="radioChange"></u-checkbox>
				</u-checkbox-group>
				<view>注册即同意</view>
				<!-- 协议地址 -->
				<view @click="linkTo('/pages/me/privacy')" style="color: #37A6FF;">《隐私政策》</view>
				和
				<view @click="linkTo('/pages/me/agreement')" style="color: #37A6FF;">《用户服务协议》</view>
			
			</view>
		</view>
	</view>
</template>

<script setup>
	import { reactive } from 'vue';
	import { onLoad} from '@dcloudio/uni-app'
	import {setSendMsg,register} from '@/api/login/login.js';
	import {commonType} from '@/api/init.js';
	import { linkTo } from '@/utils/app.js';
	
	let data = reactive({
		code: '',
		mobile: '',
		password: '',
		sending: false,
		sendTime: '获取验证码',
		count: 60,
		relation: "",
		invitation: '',
		isregisterCode: '',
		qdCodeion: '', //渠道码
		checked: false,
	})
	
	 onLoad(async ( options ) => {
		if (uni.getStorageSync('qdCodeion')) { data.qdCodeion = uni.getStorageSync('qdCodeion') }
		if (options.qdCode) { data.qdCodeion = options.qdCode }
		if (options.invitation ) { data.invitation = options.invitation }
		
		let res = await commonType(3)
		data.isregisterCode = res.value
	})
	
	/**
	 * 发送验证码
	 */
	async function sendMsg () {
		if (!data.mobile) {
			uni.showToast({
				title: '请输入手机号',
				icon: 'none',
			})
		} else if (data.mobile.length !== 11) {
			uni.showToast({
				title: '请输入正确的手机号',
				icon: 'none',
			})
		} else {
			uni.showLoading({
				title: '正在发送验证码...'
			})
			let res = await setSendMsg(data.mobile,'login')
			uni.hideLoading();
			uni.hideToast();
			if( res ){
				data.sending = true;
				uni.showToast({
					title: '验证码发送成功请注意查收',
					icon: 'none',
					duration: 1000
				})
				countDown();
			} else {
				uni.showModal({
					showCancel: false,
					title: '短信发送失败',
					content: '请一分钟后再获取验证码'
				});
			}
			
			
		}
	}
	
	
	
	/**
	 * 验证码倒计时
	 */
	function countDown() {
		console.log(data.count)
		if (data.count === 1) {
			data.count = 60;
			data.sending = false;
			data.sendTime = '获取验证码';
		} else {
			data.count = data.count - 1;
			data.sending = true;
			data.sendTime = data.count - 1 + '秒后重新获取';
			setTimeout(countDown.bind(this), 1000);
		}
	}
	
	/**
	 * 获取注册值
	 * @param {Object} e
	 */
	function inputChange(e) {
		const key = e.currentTarget.dataset.key;
		data[key] = e.detail.value;
	}
	
	/**
	 * 是否同意协议
	 * @param {Object} e
	 */
	function radioChange(e) {
		data.checked = e
	}
	
	/**
	 * 登录
	 */
	function toLogin() {
		uni.reLaunch({
			url: '/pages/login/login'
		});
	}
	
	
	/**
	 * 注册
	 */
	async function toRegister() {
		const {
			mobile,
			password,
			code,
			checked,
			invitation,
			isregisterCode,
			qdCodeion
		} = data;
		if (!mobile) {
			uni.showToast({
				title: '请输入账号',
				icon: 'none',
				duration: 1000
			})
			return
		}
		if (!code) {
			uni.showToast({
				title: '请输入验证码',
				icon: 'none',
				duration: 1000
			})
			return
		}
		if (!password) {
			uni.showToast({
				title: '请设置密码',
				icon: 'none',
				duration: 1000
			})
			return
		}
		if (password.length < 6) {
			uni.showToast({
				title: '密码位数必须大于六位',
				icon: 'none',
				duration: 1000
			})
			return
		}
		if (invitation.length == 0 && isregisterCode == '是') {
			uni.showToast({
				title: '请输入邀请码',
				icon: 'none',
				duration: 1000
			})
			return
		}
		if (!checked) {
			uni.showToast({
				title: '请先同意《隐私政策》和《用户协议》',
				icon: 'none',
				duration: 1000
			})
			return
		}
		data.logining = true;
		uni.showLoading({
			title: '注册中...'
		})
		let platform = ''
		// #ifdef APP
		platform = 'app'
		// #endif
		// #ifdef H5
		platform = 'h5'
		// #endif
		
		
		let res = await register({
			password: password,
			phone: mobile,
			msg: code,
			inviterCode: invitation,
			platform: platform,
			qdCode: qdCodeion,
		})
		if (res.code === 0) {
			uni.setStorageSync('token', res.token)
			uni.setStorageSync('userInfo', res.user)
			
			uni.showToast({
				title: '注册成功',
				icon: 'none'
			})
			setTimeout(function() {
				uni.switchTab({
					url: '/pages/index/index'
				});
			}, 1000)
		} else {
			uni.showModal({
				showCancel: false,
				title: '注册失败',
				content: res.msg
			});
		}
		uni.hideLoading();
		
	}
	
</script>

<style lang="scss" scoped>
	page {
		background: #ffffff;
	}
	*{
		box-sizing: border-box;
	}
	.bg{
		position: absolute;
		width: 100%;
		height: 100%;
		overflow: hidden;
		top: 0;
	}
	.wrapper{
		position: relative;
		padding-top: 48rpx;
		box-sizing: border-box;
	}
	.flex{
		display: flex;
	}
	.footerView {
		display: flex;
		justify-content: center;
		align-items: center;
		font-weight: 400;
		font-size: 24rpx;
		color: #333333;
		margin-top: 50rpx;
		
	}
	.cuIcon::before{
			width: 30rpx;
			height: 30rpx;
			margin-right: 12rpx;
		}
		.cuIcon-round::before {
			content: "\e6d7";
		}
		.cuIcon-radiobox:before {
			content: "\e75b";
			color: #37A6FF;
		}
	.send-msg {
		line-height: initial;
		font-weight: 400;
		font-size: 28rpx;
		color: #EC6F48;
		border: none;
		background-color: transparent;
		margin: 0;
		padding: 0;
	}
	.send-msg::after{
		border: none;
		background-color: transparent;
	}
	
	
	.container {
		position: relative;
		width: 100%;
		height: 100%;
		overflow: hidden;
		background: #ffffff;
		box-sizing: border-box;
	}

	.wrapper {
		min-height: 100vh;
		position: relative;
		z-index: 90;
	}

	.input-content {
		padding: 0 56rpx;
	}
	.cu-form-group{
		display: flex;
		flex-direction: column;
		align-items: flex-start;
		margin-bottom: 48rpx;
		background-color: transparent;
		padding: 0;
		.title{
			margin-bottom: 32rpx;
			font-weight: 400;
			font-size: 28rpx;
			color: #333333;
		}
		.input{
			width: 100%;
			// height: 84rpx;
			// line-height: 84rpx;
			background-color: #fff;
			align-items: center;
			// padding: 22rpx 32rpx 22rpx 24rpx;
			display: flex;
			align-items: center;
			justify-content: space-between;
			input{
				height: 84rpx!important;
			}
			v-deep .uni-input-input{
				height: 84rpx!important;
			}
		}
	}

	.confirm-btn {
		width: 100%;
		height: 100rpx;
		text-align: center;
		line-height: 100rpx;
		border-radius: 16rpx;
		margin-top: 40rpx;
		background: #EC6F48;
		font-size: 32rpx;
		color: #FFFFFF;

		&:after {
			border: none;
		}
	}
</style>